package org.jeecg.common.util;

import org.apache.commons.codec.digest.DigestUtils;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public class MD5Util {
	private static ThreadLocal<MessageDigest> MD5 = new ThreadLocal<MessageDigest>() {
		@Override
		protected MessageDigest initialValue() {
			try {
				return MessageDigest.getInstance("MD5");
			} catch (NoSuchAlgorithmException e) {
				throw new IllegalStateException("No md5 algorithm found");
			}
		}
	};
	public static String toHexStr(byte[] bytes) {
		int j = bytes.length;
		char[] str = new char[j * 2];
		int k = 0;
		for (int i = 0; i < j; i++) {
			byte byte0 = bytes[i];
			str[k++] = HEX_DIGITS_CHAR[byte0 >>> 4 & 0xf];
			str[k++] = HEX_DIGITS_CHAR[byte0 & 0xf];
		}
		return String.valueOf(str);
	}
	public static String getMd5(String msg) {
		MessageDigest md5 = MD5.get();
		md5.reset();
		return toHexStr(md5.digest(msg.getBytes()));
	}

	public static String byteArrayToHexString(byte b[]) {
		StringBuffer resultSb = new StringBuffer();
		for (int i = 0; i < b.length; i++){
			resultSb.append(byteToHexString(b[i]));
		}
		return resultSb.toString();
	}

	private static String byteToHexString(byte b) {
		int n = b;
		if (n < 0) {
			n += 256;
		}
		int d1 = n / 16;
		int d2 = n % 16;
		return hexDigits[d1] + hexDigits[d2];
	}

	public static String MD5Encode(String origin, String charsetname) {
		String resultString = null;
		try {
			resultString = new String(origin);
			MessageDigest md = MessageDigest.getInstance("MD5");
			if (charsetname == null || "".equals(charsetname)) {
				resultString = byteArrayToHexString(md.digest(resultString.getBytes()));
			} else {
				resultString = byteArrayToHexString(md.digest(resultString.getBytes(charsetname)));
			}
		} catch (Exception exception) {
		}
		return resultString;
	}
	public static String md5Encode(String origin, String charsetname) {
		String resultString = null;
		try {
			resultString = new String(origin);
			MessageDigest md = MessageDigest.getInstance("MD5");
			if (charsetname == null || "".equals(charsetname)) {
				resultString = byteArrayToHexString(md.digest(resultString.getBytes()));
			} else {
				resultString = byteArrayToHexString(md.digest(resultString.getBytes(charsetname)));
			}
		} catch (Exception exception) {
		}
		return resultString;
	}
	private static final String hexDigits[] = { "0", "1", "2", "3", "4", "5",
			"6", "7", "8", "9", "a", "b", "c", "d", "e", "f" };
	private static final String[] HEX_DIGITS = {"0", "1", "2", "3", "4", "5",
			"6", "7", "8", "9", "a", "b", "c", "d", "e", "f" };
	private static final char[] HEX_DIGITS_CHAR = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f'};

//	public static void main(String[] args){
//		String md5 = DigestUtils.md5Hex("88112aa3733188e0c8c2a3968ae61500&1596707859685&12574478&{\"curPageUrl\":\"https%3A%2F%2Fmarket.m.taobao.com%2Fapp%2Ftmall-def%2Fjhsbybt%2Fweb%2Findex.html%3FdisableNav%3DYES%26itemIds%3D617136337387%26spm%3D608.14027681%2F8.bubbles.d0\",\"resId\":\"8613423\",\"pageSize\":20,\"params\":\"{\\\"backupParams\\\":\\\"frontCatId,page\\\",\\\"bizId\\\":\\\"2022\\\",\\\"resId\\\":\\\"8613423\\\",\\\"pageSize\\\":20,\\\"frontCatId\\\":\\\"jingxuan\\\",\\\"page\\\":5,\\\"query\\\":\\\"\\\",\\\"itemIds\\\":\\\"613480362477,570133944073,622530871392,617136337387\\\"}\",\"appId\":\"8613423\",\"backupParams\":\"\",\"pvuuid\":\"v1-93bed822-738b-4e5e-95df-ad2790b8662c-1596698955217\",\"__pvuuid\":\"v1-93bed822-738b-4e5e-95df-ad2790b8662c-1596698955217\",\"_pvuuid\":\"v1-93bed822-738b-4e5e-95df-ad2790b8662c-1596698955217\"}");
//		System.out.println(md5);
//	}
}
