package cn.com.ctop.common.module.service.impl;

import cn.com.ctop.common.module.entity.TagInfo;
import cn.com.ctop.common.module.mapper.TagInfoMapper;
import cn.com.ctop.common.module.model.TagInfoTreeModel;
import cn.com.ctop.common.module.service.ITagInfoService;
import cn.com.ctop.common.module.utils.FindstagInfosChildrenUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.jeecg.common.constant.CacheConstant;
import org.jeecg.common.constant.CommonConstant;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 标签信息
 * @author jeecg-boot
 * @date   2020-08-26
 * @version V1.0
 */
@Service
public class TagInfoServiceImpl extends ServiceImpl<TagInfoMapper, TagInfo> implements ITagInfoService {

    /**
     * queryTreeList 对应 queryTreeList 查询所有的部门数据,以树结构形式响应给前端
     */
    @Cacheable(value = CacheConstant.SYS_TAGINFOS_CACHE)
    @Override
    public List<TagInfoTreeModel> queryTreeList() {
        LambdaQueryWrapper<TagInfo> query = new LambdaQueryWrapper<>();
        query.eq(TagInfo::getDelFlag, CommonConstant.DEL_FLAG_0.toString());
        query.orderByAsc(TagInfo::getTagOrder);
        List<TagInfo> list = this.list(query);
        // 调用wrapTreeDataToTreeList方法生成树状数据
        List<TagInfoTreeModel> listResult = FindstagInfosChildrenUtil.wrapTreeDataToTreeList(list);
        return listResult;
    }
}
